Description

While debugging #13293, I've noticed, that it can take a while to load icons, when the machine

is under load. This can potentially lead to layout change (see the screenshots), that leads

https://github.com/teampoltergeist/poltergeist#mouseeventfailed-errors.

Debugging notes:

The issue is pretty hard to debug. Here are some hints to get some additional

tricks that can help to detect the issue:

I've used this snippet so see and compare how the page

looks right before the click event should happen

20.times do

  visit edit_host_path(host)

  assert page.has_link?('Parameters', :href => '#params')

  click_link 'Parameters'

  save_screenshot

end

 Another good thing was looking into output of the `click` method

(it returns the coordinates that were clicked). Tracking that

for a while showed this:

2016-03-23T19:14:37 [app] [D] ====== click: {"position"=>{"x"=>851, "y"=>385}}

2016-03-23T19:15:20 [app] [D] ====== click: {"position"=>{"x"=>851, "y"=>385}}

2016-03-23T19:15:48 [app] [D] ====== click: {"position"=>{"x"=>851, "y"=>365}}

 The coordinates of the event when the failure happened were different to the usual

values, which was a good indication that something is wrong with the layout.

Also, running it inside VM with 2GB of RAM and running 2 more tests suites in parallel

to simulate the load in Jenkins helped to reproduce the issue.

Related issues:

Related to Foreman - Bug #13293: Intermittent host#edit parameter integration... Resolved 01/20/2016

Associated revisions

Revision f69b2276 - 03/24/2016 10:22 AM - Ivan Necas

Fixes #14340 - specify the default icon sizes to prevent intermittent layout changes

History
https://projects.theforeman.org/issues/13293
https://github.com/teampoltergeist/poltergeist#mouseeventfailed-errors


#1 - 03/24/2016 05:12 AM - Ivan Necas

- Related to Bug #13293: Intermittent host#edit parameter integration test failures after timeout added

#2 - 03/24/2016 05:13 AM - Marek Hulán

- Category set to Tests

#3 - 03/24/2016 05:17 AM - Ivan Necas

- File without-icons.png added

- File with-icons.png added

#4 - 03/24/2016 05:18 AM - Ivan Necas

- Status changed from New to Assigned

#5 - 03/24/2016 05:23 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3364 added

#6 - 03/24/2016 05:32 AM - Ivan Necas

- Description updated

#7 - 03/24/2016 11:02 AM - Ivan Necas

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset f69b227658bb395ee56e5e6869f94c7ad621e453.

#8 - 03/29/2016 04:09 AM - Dominic Cleal

- translation missing: en.field_release set to 136

Files

without-icons.png 42.8 KB 03/24/2016 Ivan Necas

with-icons.png 44.6 KB 03/24/2016 Ivan Necas
